# Queries: runquery

> [!CAUTION]
> This version of the Bid Manager API has been sunset. Users must [migrate to Bid Manager API v2](https://developers.google.com/bid-manager/how-tos/v2-migration).
>
>
> Requests to this version may return an error. If the request is successful, the following fields in retrieved [`Query`](https://developers.google.com/bid-manager/v1.1/queries#resource) resources will be empty:
>
> - [`metadata.googleCloudStoragePathForLatestReport`](https://developers.google.com/bid-manager/v1.1/queries#metadata.googleCloudStoragePathForLatestReport)
> - [`metadata.latestReportRunTimeMs`](https://developers.google.com/bid-manager/v1.1/queries#metadata.latestReportRunTimeMs)
> - [`metadata.googleDrivePathForLatestReport`](https://developers.google.com/bid-manager/v1.1/queries#metadata.googleDrivePathForLatestReport)
>
> <br />
>
> [!NOTE]
> **Note:** Requires [authorization](https://developers.google.com/bid-manager/v1.1/queries/runquery#auth).

Runs a stored query to generate a report.
[Try it now](https://developers.google.com/bid-manager/v1.1/queries/runquery#try-it).

## Request

### HTTP request

```
POST https://www.googleapis.com/doubleclickbidmanager/v1.1/query/queryId
```

### Parameters

| Parameter name | Value | Description |
|---|---|---|
| **Path parameters** |||
| `queryId` | `long` | Query ID to run. |
| **Optional query parameters** |||
| `asynchronous` | `boolean` | Whether the query should be run asynchronously. When true, this method will return immediately. When false or not specified, this method will not return until the query has finished running. (Default: `false`) |

### Authorization

This request requires authorization with the following scope:

| Scope |
|---|
| `https://www.googleapis.com/auth/doubleclickbidmanager` |

For more information, see the [authentication and authorization](https://developers.google.com/bid-manager/how-tos/authorizing) page.

### Request body

In the request body, supply data with the following structure:

```
{
  "dataRange": string,
  "reportDataStartTimeMs": long,
  "reportDataEndTimeMs": long,
  "timezoneCode": string
}
```

| Property name | Value | Description | Notes |
|---|---|---|---|
| `dataRange` | `string` | Report data range used to generate the report. <br /> Acceptable values are: - "`ALL_TIME`" - "`CURRENT_DAY`" - "`CUSTOM_DATES`" - "`LAST_14_DAYS`" - "`LAST_30_DAYS`" - "`LAST_365_DAYS`" - "`LAST_60_DAYS`" - "`LAST_7_DAYS`" - "`LAST_90_DAYS`" - "`MONTH_TO_DATE`" - "`PREVIOUS_DAY`" - "`PREVIOUS_HALF_MONTH`" - "`PREVIOUS_MONTH`" - "`PREVIOUS_QUARTER`" - "`PREVIOUS_WEEK`" - "`PREVIOUS_YEAR`" - "`QUARTER_TO_DATE`" - "`TYPE_NOT_SUPPORTED`" - "`WEEK_TO_DATE`" - "`YEAR_TO_DATE`" |   |
| `reportDataStartTimeMs` | `long` | The starting time for the data that is shown in the report. Note, `reportDataStartTimeMs` is required if `dataRange` is `CUSTOM_DATES` and ignored otherwise. |   |
| `reportDataEndTimeMs` | `long` | The ending time for the data that is shown in the report. Note, `reportDataEndTimeMs` is required if `dataRange` is `CUSTOM_DATES` and ignored otherwise. |   |
| `timezoneCode` | `string` | Canonical timezone code for report data time. Defaults to `America/New_York`. |   |

## Response

If successful, this method returns an empty response body.

## Try it!


Use the APIs Explorer below to call this method on live data and see the response.
Alternatively, try the
[standalone
Explorer](https://developers.google.com/apis-explorer/#p/doubleclickbidmanager/v1.1/doubleclickbidmanager.queries.runquery).